"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.withPreview = withPreview;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _apolloBoost = _interopRequireDefault(require("apollo-boost"));

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

function withPreview(WrappedComponent, {
  query,
  rootName,
  uri,
  showLoading = false
}) {
  var _temp;

  return _temp = class extends _react.default.Component {
    constructor(...args) {
      super(...args);
      (0, _defineProperty2.default)(this, "state", {
        data: this.props.data
      });
      (0, _defineProperty2.default)(this, "loadingEl", (() => {
        const el = document.createElement('div');
        el.style.backgroundImage = 'url(https://loading.io/spinners/balls/index.circle-slack-loading-icon.svg)';
        el.style.width = '80px';
        el.style.height = '80px';
        el.style.position = 'fixed';
        el.style.top = '5px';
        el.style.left = '5px';
        el.hidden = true;
        return el;
      })());
      (0, _defineProperty2.default)(this, "updateLoading", () => {
        const data = this.state.data;

        if (data[rootName] && data[rootName].__preview) {
          if (!data[rootName].__preview.loading) {
            setTimeout(() => {
              this.loadingEl.hidden = !data[rootName].__preview.loading;
            }, 500);
          } else {
            this.loadingEl.hidden = false;
          }
        }
      });
    }

    componentDidMount() {
      document.body.appendChild(this.loadingEl);

      if (Array.isArray(query) && query.length === 2) {
        const myQuery = (0, _graphqlTag.default)(query[1]);

        if (myQuery.definitions.length > 0) {
          const newRoot = myQuery.definitions[0].selectionSet.selections.find(selection => selection.name && selection.name.kind === 'Name' && selection.name.value === rootName);

          if (newRoot) {
            myQuery.definitions[0].selectionSet.selections = newRoot.selectionSet.selections;
            const rootValue = this.state.data && this.state.data[rootName] || {};
            this.setState({
              data: Object.assign({}, this.props.data, {
                [rootName]: Object.assign({}, rootValue, {
                  __preview: Object.assign({
                    loaded: false
                  }, rootValue.__preview || {}, {
                    loading: true,
                    error: null
                  })
                })
              })
            }, this.updateLoading);
            const client = new _apolloBoost.default({
              uri
            });
            client.query({
              query: myQuery,
              fetchPolicy: 'network-only'
            }).then(res => this.setState({
              data: Object.assign({}, this.props.data, {
                [rootName]: Object.assign({}, rootValue, res.data, {
                  __preview: {
                    loading: false,
                    error: null,
                    loaded: true
                  }
                })
              })
            }, this.updateLoading)).catch(err => this.setState({
              data: Object.assign({}, this.props.data, {
                [rootName]: {
                  __preview: {
                    loading: false,
                    error: err,
                    loaded: false
                  }
                }
              })
            }, this.updateLoading));
          }
        }
      }
    }

    componentWillUnmount() {
      document.body.removeChild(this.loadingEl);
    }

    render() {
      return _react.default.createElement(WrappedComponent, (0, _extends2.default)({}, this.props, {
        data: this.state.data
      }));
    }

  }, _temp;
}